whoa = {}
-- Defaults
whoaDefaults = {
	["smallAuraSize"] = 20,
	["largeAuraSize"] = 25,
	["classColor"] = true,
	["reactionColor"] = true,
	["comboPointFrame"] = true,
	["threatNumericIndicator"] = true,
}
cfg = cfg or whoaDefaults
function whoaSetDefaults() 
        cfg.variable = cfg.variable + 1
end

-- CreateFont --
function whoa:CreateFont(frame, name, text, x, y, font, size )
	if size == nil then size = 15 end
	if font == nil then font = STANDARD_TEXT_FONT end
local fontString = frame:CreateFontString(name) fontString:SetPoint("TOPLEFT", x, y) fontString:SetFont(font, size, "") fontString:SetText(text)
return (fontString)
end

--	Checkbutton factory.
local uniquealyzer = 1;
function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	local checkbutton = CreateFrame("CheckButton", "whoaCheckButton" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	return checkbutton;
end

--	UI panel
function whoa:CreateUI(frame)

	--	UI panel.
	whoaUI = {}
	whoaUI.panel = CreateFrame( "Frame", "whoaUI", UIParent );
	whoaUI.panel.name = "whoa UnitFrames";
	InterfaceOptions_AddCategory(whoaUI.panel);

	local title = whoa:CreateFont(whoaUI.panel, "title", "whoa UnitFrames", 15, -18, font, 15)
	title:SetFontObject(GameFontNormal) 
	title:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	local disclaimer = whoa:CreateFont(whoaUI.panel, "disclaimer", "Work in progress! At the moment is required a reload (/rl) for correct aplication of changes.", 15, -40, font, 12)
	disclaimer:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)

	--	Class colored HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, -70, "Class Color HP.");
	myCheckButton.tooltip = "Displays class colored HP bars on player frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton2:GetChecked() then
			cfg.classColor = true;
		else
			cfg.classColor = false;
		end
	end );

	--	Unit reaction color HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, -100, "Reaction colored HP bars.");
	myCheckButton.tooltip = "Display unit´s reaction colored HP bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton3:GetChecked() then
			cfg.reactionColor = true;
		else
			cfg.reactionColor = false;
		end
	end );
	
	--	Combo points in frame.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, -130, "Legacy combo points on target frame.");
	myCheckButton.tooltip = "Re-enables Wow´s old default combo point bar on target frame. Does not hides player frame´s combo points or personal resource bar. ";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton4:GetChecked() then
			SetCVar("comboPointLocation",1)
			cfg.comboPointFrame = true;
		else
			SetCVar("comboPointLocation",2)
			cfg.comboPointFrame = false;
		end
	end );
		
	--	Old threat numeric indicator.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, -160, "Legacy threat numeric indicator.");
	myCheckButton.tooltip = "Re-enables Wow´s old default threat numeric indicator which shows current´s target threat over ";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton5:GetChecked() then
			SetCVar("threatShowNumeric",1)
			cfg.threatNumericIndicator = true;
		else
			SetCVar("threatShowNumeric",0)
			cfg.threatNumericIndicator = false;
		end
	end );
end

SlashCmdList.whoaUI = function()
	InterfaceOptionsFrame_OpenToCategory(whoaUI.panel)
	InterfaceOptionsFrame_OpenToCategory(whoaUI.panel)
end

SLASH_whoaUI1 = "/whoaUI"
SLASH_whoaUI1 = "/wuf"
SlashCmdList['RELOAD'] = function() ReloadUI() end
LASH_RELOAD1 = '/rl'

whoa:CreateUI()
--	Events
function whoa:Init(event, addon, ...)
	if ( cfg.classColor == true ) then
		whoaCheckButton2:SetChecked(true)
	end
	if ( cfg.reactionColor == true ) then
		whoaCheckButton3:SetChecked(true)
	end
	if ( cfg.comboPointFrame == true) then
		whoaCheckButton4:SetChecked(true)
	end
	if ( cfg.threatNumericIndicator == true) then
		whoaCheckButton5:SetChecked(true)
	end
	if (event == "ADDON_LOADED" and addon == "whoaUnitFrames") then
		print("|cff00ccff [WhoaUnitFrames] |cff888888is now loaded. Use |cffffff00'/wuf' |cff888888to open options.")
	end
end
-- create addon frame
local whoaUI = CreateFrame("Frame", "whoaUI", UIParent)
whoaUI:SetScript("OnEvent", whoa.Init)
whoaUI:RegisterEvent("ADDON_LOADED")